"""Custom message filters made to improve commands
usage in context of Holo Users."""

from app import isAnAdmin
from modules.utils import configGet
from modules.database import col_applications
from pyrogram import filters
from pyrogram.types import Message

async def admin_func(_, __, msg: Message):
    return await isAnAdmin(msg.from_user.id)

async def allowed_func(_, __, msg: Message):
    return True if (col_applications.find_one({"user": msg.from_user.id}) is not None) else False

async def enabled_applications_func(_, __, msg: Message):
    return configGet("enabled", "features", "applications")

async def enabled_sponsorships_func(_, __, msg: Message):
    return configGet("enabled", "features", "sponsorships")

async def enabled_warnings_func(_, __, msg: Message):
    return configGet("enabled", "features", "warnings")

async def enabled_invites_check_func(_, __, msg: Message):
    return configGet("enabled", "features", "invites_check")

async def enabled_dinovoice_func(_, __, msg: Message):
    return configGet("enabled", "features", "dinovoice")

admin = filters.create(admin_func)
allowed = filters.create(allowed_func)

enabled_applications = filters.create(enabled_applications_func)
enabled_sponsorships = filters.create(enabled_sponsorships_func)
enabled_warnings = filters.create(enabled_warnings_func)
enabled_invites_check = filters.create(enabled_invites_check_func)
enabled_dinovoice = filters.create(enabled_dinovoice_func)